Bug 16186 - SqlCommand.BeginExecuteInternal does not always return the IAsyncResult
Summary: SqlCommand.BeginExecuteInternal does not always return the IAsyncResult
Status: RESOLVED FIXED
Alias: None
Product: Class Libraries
Classification: Mono
Component: System.Data (show other bugs)
Version: master
Hardware: PC Linux
: --- normal
Target Milestone: Untriaged
Assignee: Bugzilla
URL:
Depends on:
Blocks:
 
Reported: 2013-11-13 07:30 UTC by Maxime Brugidou
Modified: 2018-02-22 22:36 UTC (History)
1 user (show)

Tags:
Is this bug a regression?: ---
Last known good build:

Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.


Please create a new report on GitHub or Developer Community with your current version information, steps to reproduce, and relevant error messages or log files if you are hitting an issue that looks similar to this resolved bug and you do not yet see a matching new report.

Related Links:
Status:
RESOLVED FIXED

Description Maxime Brugidou 2013-11-13 07:30:27 UTC
In System.Data.SqlClient.SqlCommand class, the BeginExecuteInternal() method does not always return the IAsyncResult object.

See https://github.com/mono/mono/blob/master/mcs/class/System.Data/System.Data.SqlClient/SqlCommand.cs#L849

If you use a stored procedure or a prepared statement, with CommantType.StoredProcedure the ar variable is not set as the result of onnection.Tds.BeginExecuteProcedure().

This crashes your application if you start using the SqlCommand by calling manually:

* EndExecuteNonQuery() which calls
* EndExecuteInternal() which calls
* Connection.Tds.WaitFor (sqlResult.InternalResult) where sqlResult.InternalResult is the set by BeginExecuteInternal() and is null if you use a stored procedure.

This throws a NullReferenceException

To reproduce:

using(var cmd = new SqlCommand())
{
  cmd.Connection = myConnection; // your connection
  cmd.CommandType = CommandType.StoredProcedure; 
  cmd.CommandText = ""; // your procedure;
  var res = cmd.BeginExecuteNonQuery();
  cmd.EndExecuteNonQuery(res);
}

This can easily be fixed by fixing https://github.com/mono/mono/blob/master/mcs/class/System.Data/System.Data.SqlClient/SqlCommand.cs#L849 and probably https://github.com/mono/mono/blob/master/mcs/class/System.Data/System.Data.SqlClient/SqlCommand.cs#L883 for prepared statments, assigning to ar the result of the call.
Comment 1 Maxime Brugidou 2013-11-15 07:16:02 UTC
I tested and did a PR on github:

https://github.com/mono/mono/pull/809
Comment 2 Marek Safar 2018-02-22 22:36:09 UTC
Mono 5.10 has significantly improved System.Data implementation which should resolve this issue. If you can still reproduce it please reopen the issue.